/**
 * IOS 客户端的点击取词
 * To change this template use File | Settings | File Templates.
 */
 var dict ={};
 dict.queryWordNative=function(cword,sentence,x,y){
    window.readBrowserApi.showTranslate(cword,sentence,x,y);
 };
 dict.closeNativeQueryWord=function(){
    window.readBrowserApi.hideTranslate();
 };
 
 dict.bodyClick=function(){
	    window.readBrowserApi.bodyClick();
 };

(function() {
    var targetTouch, 
           targetCoord = {}, 
        targetRealCoord = {},
        currentWord,  
        rawCurrentWord, 
        content, 
        range,  
        click,  
        driver,
        isDisabled = false, 
        highlightNode,  
        ignored = ['video', 'audio', 'img'],
        ua = navigator.userAgent.toLowerCase();

    var isEngWord = function(chars) {
        return (/^[a-zA-Z\-]+$/).test(chars);
    };
    var wordArr=[];
getFilterWord=function(wordStr)
  {
       if(wordStr.trim()==""||wordStr.trim().length<1)     /*按级别筛选的单词不存在，不用查找划线，退出*/
       {
           return;
       }
       wordArr=wordStr.split(",");
  };

        var highlightTargetHtml = function() {
            content = range.extractContents();
            var node = highlightNode = document.createElement('span');
            node.className = 'hl';
            rawCurrentWord=rawCurrentWord.trim();/*rawCurrentWord是要查询意思的单词，也就是点击后的单词*/

            if(typeof(wordArr)=="undefined")    /*按级别筛选的单词不存在，wordArr没有*/
            {
                node.innerHTML = " "+rawCurrentWord;            /*点击要查询的单词，只需添加背景色即可，下面的styleTag（"catchword-style")的CSS样式只是添加浅黄色的背景色。*/
                range.insertNode(node);
            }
            else
            {

            /*查询点击的单词是否在wordArr中，不区分大小写查找，自己写的查找，没有用自带的JS查找函数。*/
                findFilterWord=false;           /*点击的单词是否在wordArr中*/
                filterWordLen=wordArr.length;       /*wordArr的长度，单词个数*/
                for(i=0;i<filterWordLen;i++)
                {
                    if(wordArr[i].toLowerCase()==rawCurrentWord.toLowerCase())      /*不区分大小写查找*/
                    {
                        findFilterWord=true;
                        break;
                    }
                }
                if(findFilterWord)      /*查找到了*/
                {
                    node.innerHTML = " "+"<font class='filterWord'>"+rawCurrentWord+"</font>";  /*除了背景色，还要加浅黄色的下划线*/
                }
                else
                {

                    node.innerHTML = " "+rawCurrentWord;/*只需加背景色*/
                }
                range.insertNode(node);
            }
        };

        var removeHighlight = function() {
            if (!range || !content || !highlightNode || !highlightNode.parentNode) {
                return;
            }
            highlightNode.parentNode.removeChild(highlightNode);
            var nnode = document.createElement('span');
            rawCurrentWord=rawCurrentWord.trim();
            findFilterWord=false;       /*点击的单词是否在wordArr中*/
            if(typeof(wordArr)=="undefined")        /*wordArr没有*/
            {
                nnode.innerHTML = " "+rawCurrentWord;       /*直接把单词添加到原处*/
            }
            else
            {
                filterWordLen=wordArr.length;       /*wordArr长度，单词个数*/
                for(i=0;i<filterWordLen;i++)
                {
                    if(wordArr[i].toLowerCase()==rawCurrentWord.toLowerCase())      /*不区分大小写*/
                    {
                        findFilterWord=true;
                        break;
                    }
                }
                if(findFilterWord)
                {
                    nnode.innerHTML = " "+"<font class='filterWord'>"+rawCurrentWord+"</font>";     /*如果还原的单词刚好在wordArr里，加上浅黄色的下划线，再放回原处*/
                }
                else
                {
                    nnode.innerHTML = " "+rawCurrentWord;       /*直接放回原处*/
                }
            }
            range.insertNode(nnode);
            range = null;
        };


    var hideResult = function() {
        if (driver.closeNativeQueryWord) {
            driver.closeNativeQueryWord();
        }
        removeHighlight();
    };
   
     var getWord = function(x, y) {
        range = document.caretRangeFromPoint(x, y);
        if (!range) {
            return '';
        }

        range.expand("word");
        targetRealCoord.cx = range.getBoundingClientRect().left;
        targetRealCoord.cy = range.getBoundingClientRect().top;
        if(targetRealCoord.cy<100 && y>300){
        	return "";
        }
        
        if(targetRealCoord.cx<100 && x>200){
        	return "";
        }
        var word =  range.cloneContents().textContent;
        return word;
    };
    
      var getSentence = function(x, y) {
        range = document.caretRangeFromPoint(x, y);
        if (!range) {
            return '';
        }

        range.expand("sentence");
        targetRealCoord.cx = range.getBoundingClientRect().left;
        targetRealCoord.cy = range.getBoundingClientRect().top;
        return range.cloneContents().textContent;
    };
    
    
    var filterNode = function(node) {
        var result = true;
        while (node != document.body) {
            if (node && node.tagName.toLowerCase() == "a") {
                result = false;
                break;
            } else {
                node = node.parentNode;
            }
        }
        return result;
    };
    

    var mainDic = function(event,endE) {
        if (!filterNode(event.target)) return;
        hideResult();

        if (isDisabled) return;

        targetTouch = event.touches[0];
        targetCoord.px = targetTouch.pageX;
        targetCoord.py = targetTouch.pageY;
        targetCoord.cx = targetTouch.clientX;
        targetCoord.cy = targetTouch.clientY;
        var element = document.elementFromPoint(targetCoord.cx, targetCoord.cy);
        if (ignored.indexOf(element.tagName) > -1) {
            return;
        }
        var currentSentence = getSentence(targetCoord.cx, targetCoord.cy);
        rawCurrentWord = getWord(targetCoord.cx, targetCoord.cy);
        currentWord= rawCurrentWord.replace(/\s+/g, '');/*|| element.innerText.indexOf(currentWord) < 0*/
        if (!isEngWord(currentWord) ) {
            range = null;
            if(dict.bodyClick){
            	dict.bodyClick();
            }
            return;
        }

        highlightTargetHtml();
        exec({
            word: currentWord,
            sentence:currentSentence,
            pos: {
                x: Math.floor(targetRealCoord.cx + highlightNode.offsetWidth / 2),
                y: Math.floor(targetRealCoord.cy + highlightNode.offsetHeight / 2)
            }
        });
        return true;
    };
     
 
    var tapHoldTriger = null,
        move = false,
        startE = null,
        endE = null,
        init = function(mode) {
    	   if(!window.jsLoadTimes){
 	    	 window.jsLoadTimes = 1;
 	       }else{
 	    	 window.jsLoadTimes++;
 	       }
 	    
 	       if(window.jsLoadTimes>1){
 	    	  return;
 	       }
            var body = document.body;
            click = mode === 'click';
            driver = window.dict ? window.dict : {};
            body.addEventListener("touchstart", function(event) {
                hideResult();
                move = false;
                startE = event;
            }, false);
            body.addEventListener("click", function(event) {
            }, false);
            body.addEventListener("touchmove", function() {
                move = true; 
                clearTimeout(tapHoldTriger);
            }, false);
            body.addEventListener("touchend", function(event) {
                endE =event; 
                tapHoldTriger = setTimeout(function() {
                	 var canCatch = window.readBrowserApi.isCanCatchWord();
                     if(canCatch){
                       mainDic(startE);
                     }
                }, 100);
            }, false);

            var styleTag = document.createElement('style'),
                defaultCSS = ([
                    '.hl{',
                    'background-color: #3DC0CC;',
                    '}'
                ]).join('\n');
            styleTag.id = 'catchword-style';
            styleTag.innerHTML = defaultCSS;
            document.querySelector('head').appendChild(styleTag);
        };

    var exec = function(opt) {
        opt.webViewWidth = window.innerWidth;
        opt.webViewHeight = window.innerHeight;

        if (/android/i.test(ua)) {
            if (driver.queryWordNative) {
                driver.queryWordNative(
                    opt.word,
                    opt.sentence,
                    opt.pos.x / window.innerWidth,
                    opt.pos.y / window.innerHeight
                );
            }
        } else if (/ipad/i.test(ua) || /iphone/i.test(ua) || /ipod/i.test(ua)) {
            var str = JSON.stringify(opt);
            var url = 'youdaobs://word_capturing_for_ios/' + str;
            document.location = url;
        }
    };
    window.catchWord = {
        init: init,
        setDisabled: function(val) {
            isDisabled = !!val;
        },
        hideResult: hideResult
    };
    init('click');
}());
